from cpl_query.extension import List

from bot_data.model.user import User
from bot_graphql.abc.filter_abc import FilterABC


class UserFilter(FilterABC):
    def __init__(
        self,
    ):
        FilterABC.__init__(self)

        self._id = None
        self._discord_id = None
        self._name = None
        self._xp = None
        self._ontime = None
        self._level = None

    def from_dict(self, values: dict):
        if "id" in values:
            self._id = values["id"]
        if "discord_id" in values:
            self._discord_id = values["discord_id"]
        if "name" in values:
            self._name = values["name"]
        if "xp" in values:
            self._xp = values["xp"]
        if "ontime" in values:
            self._ontime = values["ontime"]
        if "level" in values:
            self._level = values["level"]

    def filter(self, query: List[User]) -> List[User]:
        if self._id is not None:
            query = query.where(lambda x: x.id == self._id)

        if self._discord_id is not None:
            query = query.where(lambda x: x.discord_id == self._discord_id)

        if self._xp is not None:
            query = query.where(lambda x: x.xp == self._xp)

        # if self._ontime is not None:
        #     query = query.where(lambda x: self._client_utils.get_ontime_for_user(x) == self._ontime)

        return self.skip_and_take(query)
